Index: /trunk/zoo-project/zoo-kernel/main_conf_read.l
===================================================================
--- /trunk/zoo-project/zoo-kernel/main_conf_read.l	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/main_conf_read.l	(revision 949)
@@ -34,7 +34,7 @@
 %}
 
-attname	[a-zA-Z0-9_\-:.]+
+attname	[a-zA-Z0-9_\-:./\{\}-]+
 
-attvalue1	[%\*,;@a-zA-Z0-9_\-.:" "\"\'/\\\(\)\+\x41-\xff?&=\!$]+
+attvalue1	[%\*,;@a-zA-Z0-9_\-.:" "\"\'/\\\(\)\+\x41-\xff?&=\=\!$-]+
 
 whitesp                      [ ]
Index: /trunk/zoo-project/zoo-kernel/meta_sql.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/meta_sql.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/meta_sql.c	(revision 949)
@@ -450,8 +450,10 @@
  * @return the number of services found, -1 in case of failure
  */
-int fetchServicesFromDb(registry* reg,maps* conf, xmlDocPtr doc, xmlNodePtr n,
-			void (func) (registry *, maps *, xmlDocPtr, xmlNodePtr,
+int fetchServicesFromDb(registry* reg,maps* conf, void* doc0, void* n0,
+			void (func) (registry *, maps *, void*, void*,
 				     service *), int minimal ){
   int result=0;
+  xmlDocPtr doc=(xmlDocPtr) doc0;
+  xmlNodePtr n=(xmlNodePtr) n0;
   result=_init_sql(conf,"metadb");
   if(getMapFromMaps(conf,"lenv","dbIssue")!=NULL || result < 0)
Index: /trunk/zoo-project/zoo-kernel/meta_sql.h
===================================================================
--- /trunk/zoo-project/zoo-kernel/meta_sql.h	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/meta_sql.h	(revision 949)
@@ -41,7 +41,7 @@
 #endif
 
-  ZOO_DLL_EXPORT int fetchServicesFromDb(registry*,maps*, xmlDocPtr, xmlNodePtr,
-					 void (func) (registry *, maps *, xmlDocPtr,
-						      xmlNodePtr,service *),int);
+  ZOO_DLL_EXPORT int fetchServicesFromDb(registry*,maps*, void*, void*,
+					 void (func) (registry *, maps *, void*,
+						      void*,service *),int);
   ZOO_DLL_EXPORT service* extractServiceFromDb(maps*,const char*,int);
 
Index: /trunk/zoo-project/zoo-kernel/oas.cfg
===================================================================
--- /trunk/zoo-project/zoo-kernel/oas.cfg	(revision 949)
+++ /trunk/zoo-project/zoo-kernel/oas.cfg	(revision 949)
@@ -0,0 +1,200 @@
+[openapi]
+rootUrl=https://demo.mapmint.com/wps3/
+links=/,/api,,/conformance,/processes
+paths=/root,/api,/conformance,/processes,/processes/{id},/processes/{id}/jobs,/processes/{id}/jobs/{jobID},/processes/{id}/jobs/{jobID}/result
+paths2=,/processes/{id}/jobs/{jobID}/result/{resultID}
+paths1=p,processes/{id}/jobs,,processes/{id}/jobs/{jobID}
+parameters=id,jobID,resultID
+header_parameters=oas-header1,oas-header2
+version=3.0.1
+
+[oas-header1]
+in=header
+name=Prefer
+type=string
+required=false
+enum=respond-async
+
+[oas-header2]
+in=header
+name=Prefer
+type=string
+required=false
+enum=return=representation,return=minimal
+
+[/]
+rel=self
+type=application/json
+title=this document
+
+[root]
+method=get
+title=landing page of this API
+abstract=The landing page provides links to the API definition, the Conformance statements and the metadata about the processes offered by this service.
+tags=Home
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/root.yaml
+
+[/api]
+rel=service
+type=application/openapi+json;version=3.0
+title=the API definition
+
+[api]
+method=get
+title=This document
+abstract=This document
+tags=API
+tags_description=
+schema=
+
+[/conformance]
+rel=conformance
+type=application/json
+title=WPS 2.0 REST/JSON Binding Extension conformance classes implemented by this server
+
+[conformance]
+method=get
+title=information about standards that this API conforms to
+abstract==list all requirements classes specified in a standard (e.g., WPS REST/JSON Binding Core) that the server conforms to
+tags=Conformance
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/req-classes.yaml
+
+[/processes]
+rel=processes
+type=application/json
+title=The processes offered by this server
+
+[processes]
+method=get
+title=retrieve available processes
+abstract=Information about the available processes
+tags=GetCapabilities
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/processCollection.yaml
+
+[processes/{id}]
+method=get
+title=retrieve a process description
+abstract=A process description.
+tags=ProcessDescription
+tags_description=
+schemat=https://demo.mapmint.com/wps-rest-binding/core/openapi/schemas/process.yaml
+schematr=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/processOffering.yaml
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/process.yaml
+parameters=/components/parameters/id
+
+
+[/processes/{id}/jobs]
+rel=canonical
+type=application/json
+title=Process Description
+
+[processes/{id}/jobs]
+length=2
+method=get
+title=retrieve a list of jobs run
+abstract=A list of jobs run.
+tags=JobList
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/jobCollection.yaml
+parameters=/components/parameters/id
+method_1=post
+title_1=execute a job
+abstract_1=An execute endpoint.
+tags_1=Execute Endpoint
+tags_description_1=
+schema_1=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/result.yaml
+parameters_1=/components/parameters/id,/components/parameters/oas-header1
+
+[requestBody]
+abstract=Mandatory execute request in JSON format
+type=application/json
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/execute.yaml
+
+[/processes/{id}/jobs/{jobID}]
+rel=canonical
+type=application/json
+title=Status
+
+[processes/{id}/jobs/{jobID}]
+method=get
+title=The status of a job.
+abstract=The status of a job.
+tags=GetStatus
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/statusInfo.yaml
+parameters=/components/parameters/id,/components/parameters/jobID
+
+[/processes/{id}/jobs/{jobID}/result]
+rel=canonical
+type=application/json
+title=Get Result
+
+[processes/{id}/jobs/{jobID}/result]
+method=get
+title=The result of a job execution.
+abstract=The result of a job execution.
+tags=GetResult
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/result.yaml
+parameters=/components/parameters/id,/components/parameters/jobID
+ep=,/components/parameters/oas-header2
+
+[/processes/{id}/jobs/{jobID}/result/{resultID}]
+rel=canonical
+type=application/json
+title=Get Result
+
+[processes/{id}/jobs/{jobID}/result/{resultID}]
+method=get
+title=The result of a job execution.
+abstract=The result of a job execution.
+tags=GetResult
+tags_description=
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/valueType.yaml
+parameters=/components/parameters/id,/components/parameters/jobID,/components/parameters/resultID,/components/parameters/oas-header2
+
+
+[{id}]
+type=string
+title=The id of a process
+abstract=The id of a process
+in=path
+required=true
+example=buffer
+
+[{jobID}]
+type=string
+title=The id of a job
+abstract=The id of a job
+in=path
+required=true
+
+[{resultID}]
+type=string
+title=The id of an output
+abstract=The id of an output
+in=path
+required=true
+
+[{f}]
+default=json
+enum=json
+title=The optional f parameter
+abstract=The optional f parameter indicates the output format which the server shall provide as part of the response document.  The default format is JSON.
+in=query
+required=false
+
+[conformTo]
+rootUrl=http://www.opengis.net/spec/WPS/2.0/req/service/binding/rest-json/
+link=core
+link_1=oas30
+link_2=json
+length=3
+
+[exception]
+abstract=Exception
+type=application/json
+schema=https://raw.githubusercontent.com/opengeospatial/wps-rest-binding/master/core/openapi/schemas/exception.yaml
Index: /trunk/zoo-project/zoo-kernel/response_print.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/response_print.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/response_print.c	(revision 949)
@@ -639,6 +639,8 @@
  * @return the generated wps:ProcessOfferings xmlNodePtr 
  */
-void printGetCapabilitiesForProcess(registry *reg, maps* m,xmlDocPtr doc,xmlNodePtr nc,service* serv){
+void printGetCapabilitiesForProcess(registry *reg, maps* m,void* doc0,void* nc0,service* serv){
   xmlNsPtr ns,ns_ows,ns_xml,ns_xlink;
+  xmlDocPtr doc=(xmlDocPtr) doc0;
+  xmlNodePtr nc=(xmlNodePtr) nc0;
   xmlNodePtr n=NULL,nc1,nc2,nc3;
   map* version=getMapFromMaps(m,"main","rversion");
@@ -1000,7 +1002,9 @@
  * @return the generated wps:ProcessOfferings xmlNodePtr 
  */
-void printDescribeProcessForProcess(registry *reg, maps* m,xmlDocPtr doc,xmlNodePtr nc,service* serv){
+void printDescribeProcessForProcess(registry *reg, maps* m,void* doc0,void* nc0,service* serv){
   xmlNsPtr ns,ns_ows,ns_xlink;
   xmlNodePtr n,nc1;
+  xmlDocPtr doc=(xmlDocPtr) doc0;
+  xmlNodePtr nc=(xmlNodePtr) nc0;
   xmlNodePtr nc2 = NULL;
   map* version=getMapFromMaps(m,"main","rversion");
Index: /trunk/zoo-project/zoo-kernel/response_print.h
===================================================================
--- /trunk/zoo-project/zoo-kernel/response_print.h	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/response_print.h	(revision 949)
@@ -210,6 +210,6 @@
   xmlNodePtr printWPSHeader(xmlDocPtr,maps*,const char*,const char*,const char*,int);
   xmlNodePtr printGetCapabilitiesHeader(xmlDocPtr,maps*,const char*);
-  void printGetCapabilitiesForProcess(registry*,maps*,xmlDocPtr,xmlNodePtr,service*);
-  void printDescribeProcessForProcess(registry*,maps*,xmlDocPtr,xmlNodePtr,service*);
+  void printGetCapabilitiesForProcess(registry*,maps*,void*,void*,service*);
+  void printDescribeProcessForProcess(registry*,maps*,void*,void*,service*);
   void printFullDescription(xmlDocPtr,int,elements*,const char*,xmlNsPtr,xmlNsPtr,xmlNodePtr,int,int,const map*);
   void printDocument(maps*,xmlDocPtr,int);
Index: /trunk/zoo-project/zoo-kernel/service.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/service.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/service.c	(revision 949)
@@ -389,5 +389,5 @@
  * @return a pointer to the specific element if found, NULL in other case.
  */ 
-elements* getElements(elements* m,char *key){
+elements* getElements(elements* m,const char *key){
   elements* tmp=m;
   while(tmp!=NULL){
Index: /trunk/zoo-project/zoo-kernel/service.h
===================================================================
--- /trunk/zoo-project/zoo-kernel/service.h	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/service.h	(revision 949)
@@ -425,5 +425,5 @@
   ZOO_DLL_EXPORT void setElementsName(elements**,char*);
   ZOO_DLL_EXPORT bool hasElement(elements*,const char*);
-  ZOO_DLL_EXPORT elements* getElements(elements*,char*);
+  ZOO_DLL_EXPORT elements* getElements(elements*,const char*);
   ZOO_DLL_EXPORT void freeIOType(iotype**);
   ZOO_DLL_EXPORT void freeElements(elements**);
Index: /trunk/zoo-project/zoo-kernel/service_json.c
===================================================================
--- /trunk/zoo-project/zoo-kernel/service_json.c	(revision 948)
+++ /trunk/zoo-project/zoo-kernel/service_json.c	(revision 949)
@@ -2,5 +2,5 @@
  * Author : Gérald FENOY
  *
- *  Copyright 2017 GeoLabs SARL. All rights reserved.
+ *  Copyright 2017-2019 GeoLabs SARL. All rights reserved.
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
@@ -24,9 +24,32 @@
 
 #include "service_json.h"
+#include "json.h"
+#include <errno.h>
+#include "json_tokener.h"
+#include "stdlib.h"
+#include "mimetypes.h"
+#include "server_internal.h"
+#include "service_internal.h"
+#include <dirent.h>
 
 #ifdef __cplusplus
 extern "C" {
 #endif
-
+  /**
+   * Equivalent range keywords for WPS version 1 and 2
+   */
+  const char* rangeCorrespondances[4][2]={
+    { "rangeMin", "minimumValue" },
+    { "rangeMax", "maximumValue"},
+    { "rangeSpacing", "spacing" }, 
+    { "rangeClosure", "rangeClosure" }
+  };
+  
+
+  /**
+   * Convert a map to a json object
+   * @param myMap the map to be converted into json object
+   * @return a json_object pointer to the created json_object
+   */
   json_object* mapToJson(map* myMap){
     json_object *res=json_object_new_object();
@@ -67,4 +90,9 @@
   }
 
+  /**
+   * Convert a maps to a json object
+   * @param myMap the maps to be converted into json object
+   * @return a json_object pointer to the created json_object
+   */
   json_object* mapsToJson(maps* myMap){
     json_object *res=json_object_new_object();
@@ -73,7 +101,5 @@
       json_object *obj=NULL;
       if(cursor->content!=NULL){
-	//json_object *content=NULL;
 	obj=mapToJson(cursor->content);
-	//json_object_object_add(obj,"content",content);
       }else
 	obj=json_object_new_object();
@@ -89,4 +115,9 @@
   }
 
+  /**
+   * Convert an elements to a json object
+   * @param myElements the elements pointer to be converted into a json object
+   * @return a json_object pointer to the created json_object
+   */
   json_object* elementsToJson(elements* myElements){
     json_object *res=json_object_new_object();
@@ -112,12 +143,7 @@
 	}
 	json_object_object_add(cres,"supported",resi);
-	fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
-	fflush(stderr);
       }
       
-      dumpElements(cur->child);
       json_object_object_add(cres,"child",elementsToJson(cur->child));
-      fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
-      fflush(stderr);
 
       json_object_object_add(res,cur->name,cres);
@@ -127,4 +153,9 @@
   }
   
+  /**
+   * Convert an service to a json object
+   * @param myService the service pointer to be converted into a json object
+   * @return a json_object pointer to the created json_object
+   */
   json_object* serviceToJson(service* myService){
     json_object *res=json_object_new_object();
